from cryptography.exceptions import *
from cryptography.hazmat.primitives.asymmetric import rsa
from cryptography.hazmat.primitives import serialization

def generateKeys():
    private_key = rsa.generate_private_key(public_exponent=65537,key_size=2048)
    public_key = private_key.public_key()

    return private_key, public_key

def keysToBytes(private_key, public_key):
    prv_ser = privateKeyToBytes(private_key)
    pbc_ser = publicKeyToBytes(public_key)
    
    return prv_ser, pbc_ser

def publicKeyToBytes(public_key):
    pbc_ser = public_key.public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo)
    
    return pbc_ser

def privateKeyToBytes(private_key):
    prv_ser = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.TraditionalOpenSSL,
        encryption_algorithm=serialization.NoEncryption())
    
    return prv_ser

def bytesToKeys(private_ser, public_ser):
    private_key = serialization.load_pem_private_key(
        private_ser,
        password=None
    )
    public_key = serialization.load_pem_public_key(
        public_ser
    )
    return private_key, public_key